import java.applet.*;
import java.awt.*;
import java.awt.image.*;

public class GrayButton extends Applet
{
  Image i,gray;

  public void init()
   {
     i= this.getImage(this.getDocumentBase(),"../spec2.jpg");
     ImageFilter f = new GrayFilter();

     ImageProducer producer = new FilteredImageSource(i.getSource(),f);
     gray = this.createImage(producer);

    }


  public void update(Graphics g)
   {
    g.drawImage(i,0,0,this);
   }


  public boolean mouseDown(Event e,int x,int y)
   {
     Graphics g = this.getGraphics();
     Dimension d = this.size();
     g.clearRect(0,0,d.width,d.height);
     g.drawImage(gray,0,0,this);
     return true;
   }

  public boolean mouseUp(Event e,int x,int y)
  {
    update(this.getGraphics());
    return true;
  }

}


//Filter an image by averaging all of its colors with white

class GrayFilter extends RGBImageFilter
{
 public GrayFilter() { canFilterIndexColorModel = true;}

 public int filterRGB(int x,int y,int rgb)
  {
   int a = rgb & 0xff00000;
   int r = ((rgb & 0xff0000) + 0xff0000)/2;
   int g =  ((rgb & 0x00ff00) + 0x00ff00)/2;
   int b =  ((rgb & 0x0000ff) + 0x0000ff)/2;
   return a|r|g|b;
  }

}
    
     
